<template>
  <div class="flex mt-4 justify-content-center">
    <h1>Notifications</h1>
  </div>
  <div class="flex justify-content-center mt-5">
    <div class="flex-2">
      <div class="flex mt-2 justify-content-center">
        <input
            type="text"
            v-model="searchTerm"
            placeholder="Search notifications..."
            class="p-inputtext p-component"
        />
      </div>
      <button @click="reloadNotifications">Refresh Notifications</button>
      <ScrollPanel style="width: 100%; height: 90rem; overflow-y: auto">
        <div class="grid-container">
          <div class="grid-item" v-for="(item, index) in getNotifications()" :key="index">
            <Card>
              <template #header></template>
              <template #title>
                <h4>
                  <u
                  ><i>{{ index + 1 }}.</i> {{ item.title }}</u
                  >
                </h4>
              </template>
              <template #subtitle>
                <i> {{ formatDate(item.datePosted) }} </i>
                <Divider></Divider>
              </template>
              <Divider></Divider>
              <template #content>
                <p>{{ item.description }}</p>
              </template>
            </Card>
            <div v-if="isLastItem(index)" style="height: 20rem"></div>
          </div>
        </div>
      </ScrollPanel>
    </div>
  </div>
</template>

<script setup lang="ts">
import {useNotificationsStore} from '../../stores/notifications/notifications';
import ScrollPanel from 'primevue/scrollpanel';
import Card from 'primevue/card';
import Divider from 'primevue/divider';
import {ref, watch} from "vue";

const store: any = useNotificationsStore();
const searchTerm = ref('');

function formatDate(date: Date): string {
  const day = date.getDate().toString().padStart(2, '0');
  const month = (date.getMonth() + 1).toString().padStart(2, '0');
  const year = date.getFullYear().toString();

  return `${day}. ${month}. ${year}`;
}

function isLastItem(index: number) {
  return index + 1 === store.notifications.length;
}

// Filter by title and description
function getNotifications() {
  return store.notifications.filter((notification: any) => {
    return notification.title.toLowerCase().includes(searchTerm.value.toLowerCase()) ||
        notification.description.toLowerCase().includes(searchTerm.value.toLowerCase());
  });
}


function reloadNotifications() {
  getNotifications();
}
</script>

<style scoped>
.grid-container {
  display: grid;
  grid-template-columns: repeat(1, 1fr);
  grid-gap: 3rem;
}
</style>
